Description

The FragmentWatcher art module (included in artdag/ArtModules) already has reporting of the fragment IDs of individual Empty
fragments. It would be helpful to also have this level of detail in the tracking of Missing fragments.

Related issues:
Related to artdaq - Feature #5958: Add the ability to flag various conditions... Closed 12/18/2012

History

#1 - 08/15/2019 12:12 PM - Kurt Biery

The candidate code changes are on the feature/23131_FragWatcher_MissingFragDetail branch in the artdaq repo. This branch was created based
on the v3_06_00 tag.

In addition to adding detailed tracking and reporting of the fragment IDs for missing fragments, | removed blocks of code in the constructor and
destructor that dealt with the metrics_pset. This code must have been a hold-over from whatever source code file(s) that | used as a starting point for
the FragmentWatcher, but my current sense is that it was very much out-of-place there. The configuration snippet for the FragmentWatcher will likely
never include information about metrics.

| also tried to organize the TRACE messages and explain their intention with comments in the code.

#2 - 08/15/2019 12:27 PM - Kurt Biery

| tested these changes in an artdag-demo system on sbnd-dag33 with the mediumsystem_with_routing_master sample configuration.
Here are sample file metrics entries:

[biery@sbnd-dag33 eventbuilder]$ pwd
/home/nfs/biery/gpmTest/daglogs/eventbuilder
[biery@sbnd-dag33 eventbuilder]$ egrep 'EventsWith|EventsProcessed' evb_13508_metrics.log

Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsProcessed: 80 events.

Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsWith50PctMissingFragments: 0 events.
Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsWithlOPctMissingFragments: 16 events.
Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsWithMissingFragments: 16 events.

Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsWithlOPctEmptyFragments: 76 events.
Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsWithEmptyFragments: 76 events.

Thu Aug 15 08:26:33 2019: FileMetric: EventBuilder3_artl.EventsWith50PctEmptyFragments: 76 events.

Here are sample logfile messages:

[biery@sbnd-dag33 art]$ pwd

/home/nfs/biery/gpmTest/daglogs/art

[biery@sbnd-dag33 art]$ grep -A 2 -i msg-w art-sbnd-dag33-2019081508254*.1log | tail -15
art-sbnd-dag33-20190815082548-13508.10g:%MSG-w EventBuilder3_artl_FragmentWatcher: DAQ 15-Aug-2019 08:26:18 C
DT Booted FragmentWatcher_module.cc:216

art-sbnd-dag33-20190815082548-13508.1log-Event 224: total_fragments=9, fragmentIDs for empty_fragments: 1, 2, 3
, 4, 5, 6, 8, 9

art-sbnd-dag33-20190815082548-13508.1og-%$MSG

art-sbnd-dag33-20190815082548-13508.10g9:%MSG-w EventBuilder3_artl_FragmentWatcher: DAQ 15-Aug-2019 08:26:18 C
DT Booted FragmentWatcher_module.cc:202

art-sbnd-dag33-20190815082548-13508.1log-Event 225: total_fragments=9, fragmentIDs for missing_fragments: 7
art-sbnd-dag33-20190815082548-13508.10og—-%MSG

art-sbnd-dag33-20190815082548-13508.10g:%MSG-w EventBuilder3_artl_FragmentWatcher: DAQ 15-Aug-2019 08:26:18 C
DT Booted FragmentWatcher_module.cc:216

art-sbnd-dag33-20190815082548-13508.1log-Event 225: total_fragments=9, fragmentIDs for empty_fragments: 1, 2, 3
, 4, 5, 6, 8, 9

art-sbnd-dag33-20190815082548-13508.1og-%$MSG
art-sbnd-dag33-20190815082548-13508.
DT Booted FragmentWatcher_module.cc:
art-sbnd-dag33-20190815082548-13508.
art-sbnd-dag33-20190815082548-13508.
art-sbnd-dag33-20190815082548-13508.

log:%$MSG-w EventBuilder3_artl_ FragmentWatcher:

202
log-Event 226:
log-%MSG

total_fragments=9, fragmentIDs

log:$MSG-w EventBuilder3_artl_FragmentWatcher:

DAQ 15-Aug-2019 08:26:18 C

for missing_fragments: 7

DAQ 15-Aug-2019 08:26:18 C

216
log-Event 226:

DT Booted FragmentWatcher_module.cc:

art-sbnd-dag33-20190815082548-13508. total_fragments=9, fragmentIDs

0 B B G B, 9

art-sbnd-dag33-20190815082548-13508.109-%MSG

Here are sample TRACE messages:

19622 08-15 08:26:16.909988 13507 13507 1 EventBuilderl_artl_FragmentWatcher
ragments=9, fragmentIDs for empty_fragments: 1, 2, 3, 4, 5, 6, 8, 9

19623 08-15
ragments=9,

08:26:16.909812 13507 13507 1
fragmentIDs for missing_fragments: 7

EventBuilderl_artl_FragmentWatcher

19624 08-15 08:26:16.909797 13507 13507 1 EventBuilderl_artl_FragmentWatcher
ent: total_fragments=9, missing_fragments=1, empty_fragments=8 (66 events processed)
19724 08-15 08:26:16.795336 13507 13507 1 EventBuilderl_artl_FragmentWatcher

with_50pct_missing_fragments=0, events_with_50pct_empty_fragments=65
19725 08-15 08:26:16.795326 13507 13507 1 EventBuilderl_artl_FragmentWatcher
with_10pct_missing_fragments=11, events_with_10pct_empty_fragments=65

19726 08-15 08:26:16.795321 13507 13507 1 EventBuilderl_artl_FragmentWatcher
with_missing_fragments=11, events_with_empty_fragments=65
19727 08-15 08:26:16.795250 13507 13507 1 EventBuilderl_artl_FragmentWatcher

ragments=9,
19728 08-15
ragments=9,

fragmentIDs for empty_fragments: 1,
08:26:16.795146 13507 13507 1
fragmentIDs for missing_fragments: 7

2, 3, 4, 5, 6, 8, 9

EventBuilderl_artl_FragmentWatcher

19729 08-15 08:26:16.795136 13507 13507 1 EventBuilderl_artl_FragmentWatcher
ent: total_fragments=9, missing_fragments=1, empty_fragments=8 (65 events processed)
19739 08-15 08:26:16.794524 13507 13507 1 EventBuilderl_artl_FragmentWatcher

with_50pct_missing_fragments=0, events_with_50pct_empty_fragments=64

The local changes to the EventBuilder configuration files were the following:

-—— a/simple_test_config/mediumsystem_with_routing_master/EventBuilderl.fcl
+++ b/simple_test_config/mediumsystem_with_routing_master/EventBuilderl.fcl
@@ -27,6 +27,7 @@ dag: {
send_requests: true
request_port: 3001
request_address: "227.128.12.26"
+ multicast_interface_ip: "192.168.230.0"
expected_art_event_processing_time_us: 2000000
routing_token_config: {
@@ -46,8 +47,8 @@ dag: {

evbFile: {
metricPluginType: "file"
level: 4
= fileName: "eventbuilder/evb_%UID%_metrics.log"

= absolute_file_path: false

wrn

wrn

do4

do7

do7

doe

wrn

wrn

do4

do7

+ fileName: "/home/nfs/biery/gpmTest/daglogs/eventbuilder/evb_%UID%_metrics.log"
+ absolute_file_path: true
uniquify: true
}
}
@@ -61,12 +62,16 @Q@ outputs: {
physics: {
analyzers: {
+ fragmentwatcher: {
+ metrics_reporting level: 1
i's mode_bitmask: 7
+ module_type: "FragmentWatcher"
+ }
}
- producers: {
-}
+ producers: { }
+ al: [ fragmentwatcher ]
my_output_modules: [ rootNetOutput ]
source: {

#3 - 10/14/2019 10:17 AM - Eric Flumerfelt
- Status changed from New to Assigned

- Co-Assignees Eric Flumerfelt added

Performed code review. | noticed that the fragmentHandles are iterated over twice; it may be more performant to only iterate over them once and do
both the missing and empty Fragment checks at that time. Also, it would be nice if the metrics reporting level for at least
DETAILED_COUNTS_MODE was different, so that the XML could be sent to a different metric destination.

Code tested and verified.

#4 - 10/14/2019 11:29 AM - Eric Flumerfelt

Thinking more about my comments, I'd almost suggest replacing the mode_bitmask and metrics_reporting_level with "basic_counts_metric_level",
"fractional_counts_metric_level", and "detailed_counts_metric_level" and indicate in the documentation that a level of 0 means to disable that
reporting, which would be the default for fractional and detailed modes.

#5 - 10/18/2019 02:51 PM - Eric Flumerfelt
- Related to Feature #5958: Add the ability to flag various conditions in a RawEvent added

#6 - 01/07/2020 10:12 AM - Eric Flumerfelt

| have made a set of changes on this branch that should avoid a potential logic error when different Fragment IDs are missing in the first few events of
arun.

We should also consider a mechanism by which FragmentWatcher can reset its expected Fragment ID list, for when the DAQ changes its expected
Fragment IDs.
